%relativistische Teilchenbewegung
%Mit: c=1; System des Beobachters: x,y,z,t  System des Teilchens: tau

%Simutlationsdauer
dauer=100000; %100000

%Darstellungsdauer
darst_t=100;

%Staerke der Kraft
faktor=0.01;

%Parameter
dtau=1;
neuladen=10;
data=struct();

%Startkonfiguration
x0=[0;0;0];
v0=[0.1;0;0.1];

%_________________________Normierung
norm=sqrt(sum(v0.^2));
if(norm>0.8)
    v0=v0/norm;
end


%Masse
m0=1;

%Grenzen
xmin=-100;
xmax=-xmin;
ymin=-100;
ymax=-ymin;
zmin=-100;
zmax=-zmin;

%%%%%%%%%%%%%%%%%%%%%%inititalisierung
x=x0;
v=v0;
xvec=x;

%Darstellung
teilchenbahn=figure;
%_______________________________________________________3D - Kurve
subplot(3,5,[1,2,3,6,7,8,11,12,13])
pc=plot3(x(1),x(2),x(3),'b+');
hold on
po=plot3(x(1),x(2),x(3),'ro');
set(po,'markersize',3);
grid on
xlim([xmin,xmax]);
ylim([ymin,ymax]);
zlim([zmin,zmax]);
ausg=['hallo'];
data.Titel=title(ausg);
data.D3achse=axes;
%________________________________________________________Energie
subplot(3,5,[4,5])
pE=plot(0,0,'b');
data.D3Titel=title('Energie');


%________________________________________________________Geschwindigkeit
subplot(3,5,[9,10,14,15])
pv=plot(0,0,'b');
set(pv,'displayname','v^2, Eigenzeit');
hold on
prv=plot(0,0,'r');
set(prv,'displayname','v^2, Beobachter');
legend('show');
legend('location','south');
data.D3Titel=title('  v^2 ');


%__________________________________________________________Eingabe
data.togbutx=uicontrol('STYLE','togglebutton', ....
                   'Position',[10,380,40,20],...
                   'String','Fx'); 
data.togbut_x=uicontrol('STYLE','togglebutton', ....
                   'Position',[50,380,40,20],...
                   'String','-Fx'); 
               
data.togbuty=uicontrol('STYLE','togglebutton', ....
                   'Position',[10,360,40,20],...
                   'String','Fy'); 
data.togbut_y=uicontrol('STYLE','togglebutton', ....
                   'Position',[50,360,40,20],...
                   'String','-Fy'); 

data.togbutz=uicontrol('STYLE','togglebutton', ....
                   'Position',[10,340,40,20],...
                   'String','Fz'); 
data.togbut_z=uicontrol('STYLE','togglebutton', ....
                   'Position',[50,340,40,20],...
                   'String','-Fz'); 

data.reset=uicontrol('STYLE','pushbutton', ....
                   'Position',[5,5,40,20],...
                   'String','v~0',...
                   'Callback','v=[0.001;0.001;0.001];'); 

%Initialisierung
aus=false;
count=0;
neul=0;
%av=0;
%ax=0;

%erste Werte
gam=sqrt(1/abs(1-sum(v.^2)));
Evec=m0*gam;
vvec=sum(v.^2);
vrvec=sum((v/gam).^2);
tvec=0;
cvec=0;

while(~aus)
    %____________________________Berechnungen
    
    %__Bestimmung der Kraft
    F=[0;0;0];
    if(get(data.togbutx,'value')==1)
        F=faktor*[1;0;0]+F;
    end
    if(get(data.togbut_x,'value')==1)
        F=-faktor*[1;0;0]+F;
    end
    if(get(data.togbuty,'value')==1)
        F=faktor*[0;1;0]+F;
    end
    if(get(data.togbut_y,'value')==1)
        F=-faktor*[0;1;0]+F;
    end
    if(get(data.togbutz,'value')==1)
        F=faktor*[0;0;1]+F;
    end
    if(get(data.togbut_z,'value')==1)
         F=-faktor*[0;0;1]+F;
    end
    
    %__Berechnung der Beschleunigung
    gam=sqrt(1/abs(1-sum(v.^2)));
    ev=v/sqrt(sum(v.^2));
    
    Fv=(F.'*ev)*ev;
    Fx=(F-Fv);
    ahv=Fv/(gam^3*sum(v.^2)+gam)/m0;
    ahx=Fx/(gam)/m0;
    a=ahv+ahx;

    
    %_______Berechnung der Bewegung
    
    v=v+a*dtau;
    x=x+v*dtau;

    
   %___________ relativistische Gr??en
    E=m0*gam;
    mr=gam*m0;
    dt=dtau*gam;
    
    %::::::::::::::::::::::::::: Speichern
    xvec=[xvec,x];
    Evec=[Evec,E];
    vvec=[vvec,sum(v.^2)];
    cvec=[cvec,count];
    tvec=[tvec,tvec(end)+dt];
    vrvec=[vrvec,sum((v/gam).^2)];
    
    %%%%%%%%%%%%%%%%%%%%% periodische Raender
    if(x(1)<xmin)
        x(1)=x(1)+(xmax-xmin);
        neul=neul+1;
    end
    if(x(1)>xmax)
        x(1)=x(1)-(xmax-xmin);
        neul=neul+1;
    end
    if(x(2)<ymin)
        x(2)=x(2)+(ymax-ymin);
        neul=neul+1;
    end
    if(x(2)>ymax)
        x(2)=x(2)-(ymax-ymin);
        neul=neul+1;
    end
    if(x(3)<zmin)
        x(3)=x(3)+(zmax-zmin);
        neul=neul+1;
    end
    if(x(3)>zmax)
        x(3)=x(3)-(zmax-zmin);
        neul=neul+1;
    end
    %__________________________Reload
    
    if(neul>neuladen)
        neul=0;
        xvec=x;
        Evec=m0*gam;
        vvec=sum(v.^2);
        vrvec=sum((v/gam).^2);
        tvec=0;
        cvec=0;
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%% Darstellung
    
    set(pc,'xdata',x(1),'ydata',x(2),'zdata',x(3));
    set(po,'xdata',xvec(1,:),'ydata',xvec(2,:),'zdata',xvec(3,:));
    ausg=['dt =', num2str(dt),'    v^2 =', num2str(sum(v.^2)),' m_R=',num2str(mr)];
    set(data.Titel,'string',ausg);
    
    set(pE,'xdata',cvec,'ydata',Evec);
    set(pv,'xdata',cvec,'ydata',vvec);
    set(prv,'xdata',cvec,'ydata',vrvec);

    
    %Zeichnen und Pause
    pause(dt/darst_t);
    drawnow
    
    % Ende
    count=count+1;
    if(count>dauer)
        break;
    end
end


