%Relativistischer Versuch, c=1;

%x,y,vx,vy,t
%tau

x1=10;
x2=20;
y0=0;
vy=-0.99;


endtau=5;
sumtau=0;
endt=5;
sumt=0;
beschlv=5;

figure
p1=plot(x1,y0,'.b');
set(p1,'markersize',8);
set(p1,'Displayname','nicht-relativistisch');

hold on
p2=plot(x2,y0,'.r');
set(p2,'markersize',8);
set(p2,'Displayname','relativistisch');

grid on
legend('show');
legend('location','west');
title('Mesonen');
gam=1./sqrt(1-(vy.^2));
xlim([0,23]);
ylim([vy*endt*gam*1.2,0]);

y1=y0;
y2=y0;
yv1=y1;
yv2=y2;

xv1=x1;
xv2=x2;

dt=1;
for t=1:dt:endt
    
    vy1=vy;
    y1=y1+vy1*dt;
    yv1=[yv1,y1];
   
    xv1=[xv1,x1];
    
    set(p1,'xdata',xv1,'ydata',yv1);
    
    if isfinite(dt)
       sumt=sumt+dt;
       pause(dt/beschlv);
       drawnow
    end
    
end

dtau=1;
for tau=1:dtau:endtau
    
    vy2=vy;
    
    gam=1./sqrt(1-(vy2.^2));
    dt=gam*dtau;
    
    y2=y2+vy2*dt;
    yv2=[yv2,y2];
   
    xv2=[xv2,x2];
    
    set(p2,'xdata',xv2,'ydata',yv2);
    
    
    if isfinite(dt)
       sumtau=sumtau+dt;
       pause(dt/beschlv);
       drawnow
    end
    
end
    
ausg=['n.r.: t=',num2str(sumt),'     r.: t=',num2str(sumtau)];
title(ausg);

    